]> git.ipfire.org Git - thirdparty/linux.git/blame - Kbuild
Merge tag 'for-6.9-rc4-tag' of git://git.kernel.org/pub/scm/linux/kernel/git/kdave...
[thirdparty/linux.git] / Kbuild
CommitLineData
b2441318 1# SPDX-License-Identifier: GPL-2.0
86feeaa8
SR
2#
3# Kbuild for top-level directory of the kernel
86feeaa8 4
ed7ceac1
MY
5# Prepare global headers and check sanity before descending into sub-directories
6# ---------------------------------------------------------------------------
7
01d509a4 8# Generate bounds.h
39664e2f
MY
9
10bounds-file := include/generated/bounds.h
11
8a58e162 12targets := kernel/bounds.s
39664e2f 13
11fda148 14$(bounds-file): kernel/bounds.s FORCE
70a4fd6c 15 $(call filechk,offsets,__LINUX_BOUNDS_H__)
1cdf25d7 16
01d509a4 17# Generate timeconst.h
0a227985
NMG
18
19timeconst-file := include/generated/timeconst.h
20
ba97df45 21filechk_gentimeconst = echo $(CONFIG_HZ) | bc -q $<
0a227985 22
11fda148 23$(timeconst-file): kernel/time/timeconst.bc FORCE
0a227985
NMG
24 $(call filechk,gentimeconst)
25
01d509a4 26# Generate asm-offsets.h
86feeaa8 27
559df2e0 28offsets-file := include/generated/asm-offsets.h
86feeaa8 29
6752ed90 30targets += arch/$(SRCARCH)/kernel/asm-offsets.s
1cdf25d7 31
11fda148 32arch/$(SRCARCH)/kernel/asm-offsets.s: $(timeconst-file) $(bounds-file)
86feeaa8 33
11fda148 34$(offsets-file): arch/$(SRCARCH)/kernel/asm-offsets.s FORCE
70a4fd6c 35 $(call filechk,offsets,__ASM_OFFSETS_H__)
86feeaa8 36
01d509a4 37# Check for missing system calls
c53aeca0
SR
38
39quiet_cmd_syscalls = CALL $<
44656fa0 40 cmd_syscalls = $(CONFIG_SHELL) $< $(CC) $(c_flags) $(missing_syscalls_flags)
c53aeca0 41
ed7ceac1
MY
42PHONY += missing-syscalls
43missing-syscalls: scripts/checksyscalls.sh $(offsets-file)
c53aeca0 44 $(call cmd,syscalls)
1cdf25d7 45
b10fdeea
MY
46# Check the manual modification of atomic headers
47
48quiet_cmd_check_sha1 = CHKSHA1 $<
49 cmd_check_sha1 = \
50 if ! command -v sha1sum >/dev/null; then \
51 echo "warning: cannot check the header due to sha1sum missing"; \
52 exit 0; \
53 fi; \
54 if [ "$$(sed -n '$$s:// ::p' $<)" != \
55 "$$(sed '$$d' $< | sha1sum | sed 's/ .*//')" ]; then \
56 echo "error: $< has been modified." >&2; \
57 exit 1; \
58 fi; \
59 touch $@
60
61atomic-checks += $(addprefix $(obj)/.checked-, \
62 atomic-arch-fallback.h \
63 atomic-instrumented.h \
64 atomic-long.h)
65
66targets += $(atomic-checks)
67$(atomic-checks): $(obj)/.checked-%: include/linux/atomic/% FORCE
68 $(call if_changed,check_sha1)
ed7ceac1
MY
69
70# A phony target that depends on all the preparation targets
71
72PHONY += prepare
b10fdeea 73prepare: $(offsets-file) missing-syscalls $(atomic-checks)
ed7ceac1 74 @:
5750121a
MY
75
76# Ordinary directory descending
77# ---------------------------------------------------------------------------
78
79obj-y += init/
80obj-y += usr/
81obj-y += arch/$(SRCARCH)/
82obj-y += $(ARCH_CORE)
83obj-y += kernel/
84obj-y += certs/
85obj-y += mm/
86obj-y += fs/
87obj-y += ipc/
88obj-y += security/
89obj-y += crypto/
90obj-$(CONFIG_BLOCK) += block/
91obj-$(CONFIG_IO_URING) += io_uring/
8afc66e8 92obj-$(CONFIG_RUST) += rust/
5750121a
MY
93obj-y += $(ARCH_LIB)
94obj-y += drivers/
95obj-y += sound/
96obj-$(CONFIG_SAMPLES) += samples/
97obj-$(CONFIG_NET) += net/
98obj-y += virt/
99obj-y += $(ARCH_DRIVERS)